\name{CATCosinor}
\alias{CATCosinor}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Cosinor Analysis
%%  ~~function to do ... ~~
}
\description{ Perform one of various cosinor analyses:  single cosinor, multiple-component cosinor, progressive single cosinor, progressive multiple-component cosinor.
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
}
\usage{
CATCosinor(TimeCol=2,Y=c(4,6,7), Components=3, window="noFilt", RefDateTime="201302030000",  timeFormat="YmdHM", RangeDateTime=list(Start=0, End=0), Units='Hour', dt=0, Progressive=list(Span=0, Increment=0), Period=list(Set=c(24,12,8),Start=0,Increment=1,End=0),header=F, Skip=0, Colors="BW",Graphics="pdf",Output=list(Txt=F,Dat=T,TxtAmp=F,Doc=T,HeatMap=F,LineGraphs=F),Console=F,Debug=FALSE,fileName=fileName,functionName='CallCos3varProg')
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{TimeCol}{Column where time is found.  Can be in one column, or Time in one, and Date in another.  Or this column can contain a numeric number of hours instead.  The format of the TimeCol is given by timeFormat parameter.
%%     ~~Describe \code{startX} here~~
}

  \item{Y}{The column number(s) of the data to be analyzed.  Can be a numeric scalar, or vector.
%%     ~~Describe \code{lum} here~~
}
  \item{Components}{Default=1.  Indicates if this is a single or multiple component cosinor analysis, where the number of components is specified (>0).  
%%     ~~Describe \code{export} here~~
}
  \item{window}{Data will be convolved with a window:  hanning, hamming, bartlett, blackman.  Default="noFilt"
%%     ~~Describe \code{sizePts} here~~
}
  \item{RefDateTime}{Date used as reference, and subtracted from all data dates, to make the number smaller.  **Must be in the same time zone!!!!!**
             if RefDateTime = 0, use the 1st date of the data as the RefDateTime 
             if RefDateTime = 12, use midnight of the same day as the data starts 
%%     ~~Describe \code{Span} here~~
}
  \item{timeFormat}{RefDateTime and the time in the data file should both use the same date/time format.   Can be "numeric" or "%Y%m%d%H%M"   i.e., "%Y%m%d%H%M", or if = "numeric", time column in data file can be simple numbers (0 - 99999...)
}

  \item{RangeDateTime}{specify in the form of a list:  RangeDateTime=list(Start=12, End=0)      
        $Start:  Analysis is started at this date/time.  May be before 1st data date.
             if Start = 0, use the 1st time in the data set
             if Start = 12 use Midnight at the start of the 1st date of the data as the StartDate 
        $End:    Analysis ends at this date/time.  May be after last data date.
             if End = 0, use the last time in the data set
             if End = 12 use the midnight at the end of the last date of the data as the EndDate   
%%     ~~Describe \code{k} here~~
}
  \item{Units}{Units (Hour, Year, Week or Day) for Span and Increment arguments, as well as Period arguments
%%     ~~Describe \code{yLab} here~~
}
  \item{dt}{When equidistant data, dt indicates the sampling interval.  If dt =0, no periodogram is done.  Data is assumed to be equidistant when this is nonzero
%%     ~~Describe \code{modulo} here~~
}
  \item{Progressive}{specify in the form of a list:  Progressive=list(Span=0, Increment=0)
     $Span : number of Days, Wks or Yrs in a subset of full data  -- multiple spans calculated
               If 0, assumes no progession, Span is set to the full dataset length, and Increment = full data set  
     $Increment: number of Days, Wks or Yrs  (uses same unit as set for Span) to shift between span analyses
               If 0, assumes no progession, Span is set to the full dataset length, and Increment = full data set 
%%     ~~Describe \code{Rverbose} here~~
}
  \item{Period}{specify in the form of a list:   Period=list(Set=0,Start=0,Increment=1,End=0)
     $Start : First (and largest) period to calculate, in units of Days, Wks or Yrs (as set by Units);  (Span/1)   0 is Default: full time range analyzed [in hours?] (RangeDateTime$End-RangeDateTime$Start)= MyData_length; or if progressive, Span/1;  
     $Increment : Increment to starting period, in units of Days, Wks or Yrs (as set by Units).  Defaults to 1;   0 is invalid  -- says use default
    $End : Last (and smallest) period to calculate, in units of Days, Wks or Yrs (as set by Units).  Defaults to 2;  (1 is too small) 0 is invalid  -- says use default
    $Set :  Overrides Period$Start and $Increment, to specify a specific set of periods to analyze (as set by Units).  If $End is set, it will determine ending period. Set can be in the format of a single number, or an array:  c(1,2,3) or c(8,12:24).  When Components=1, each period specified in the vector will be assessed by cosinor independently.  When parameter Components is >1, Period$Set must have a correspondig number of components, which assessed together in a multiple component cosinor.  If Set=0, a series of periods are analyzed (spectrum) according to Period$Start, $Increment, $End (or their default value, if not specified).  For a spectrum, only the maximum period, or the maximum period per span, from a spectrum is displayed on the graphics file.  Otherwise, all periods are displayed on the graphic 
%%     ~~Describe \code{RmaxGap} here~~
}
  \item{header}{Boolean T/F to indicate if the file has a header.  Header is used as column names.
%%     ~~Describe \code{Skip} here~~
}
  \item{Skip}{is a parameter to the R read.table function.  It is needed if you have multiple lines of header – the first row will be read as the header (unless you set header=F) and skip indicates how many rows to skip before reading data. 
%%     ~~Describe \code{nFiles} here~~
}
  \item{Colors}{Colors for a heatmap.  "Heat" renders the heat map in colors;  "BW" renders the heatmap in grayscale
%%     ~~Describe \code{Smoothing} here~~
}
  \item{Graphics}{The main results of CATCosinor are sent to a files when Console=F.  Default file output type is "pdf".   Possible values: "jpg, pdf, tif, png.   TIFF and PNG are higher resolution than jpeg and pdf.  (Additional files can be created with the Output parameter.)

  Plots in PNG and JPEG format can easily be converted to many other bitmap formats, and both can be displayed in modern web browsers. The PNG format is lossless and is best for line diagrams and blocks of colour. The JPEG format is lossy, but may be useful for image plots, for example. It is most often used in html web pages.  TIFF is a meta-format: the default format written by tiff is lossless and stores RGB (and alpha where appropriate) values uncompressed—such files are widely accepted, which is their main virtue over PNG.
%%     ~~Describe \code{Actogram} here~~
}
  \item{Output}{Txt=T will generate a comma delimited .txt document containing output;  DAT=T will generate a machine readable, tab delimited output of cosinor results: MESOR, Amplitude, Phase, standard error values, and others;  Doc will generate a nicely formatted Word doc;  HeatMap will generate a heatmap, but only when more than one period is specified for a progressive analysis;  LineGraphs will generate a set of graphs plotting MESOR, Amplitude, Acrophase over time--too many when you do a progressive
%%     ~~Describe \code{AutoCorr} here~~
}
  \item{Console}{Default is F.  When Console=T output will be redirected to the RStudio Console, instead of an output file.
%%     ~~Describe \code{CrossCorr} here~~
}
  \item{Debug}{for debug and can take on values of -1, 0,1 or 2.  0 turns off debug information.  1 or 2 add increasing amounts of debug information. -1 minimizes information displayed on graphs.
%%     ~~Describe \code{Console} here~~
}
  \item{fileName}{The path to a data file to be processed.  If this is blank, CATCosinor will solicit a file from the user by a dialogue box.
%%     ~~Describe \code{Console} here~~
}
  \item{functionName}{Brief name for this run, used to label output.
%%     ~~Describe \code{Darkness1} here~~
}
}
\section{Input Data:}{  
Input data need not be equidistant, discrete. Time may be in column, and may be numeric or character.  (The time column can be replaced by a column having a numeric number of hours from reference.)  Multiple numeric variable columns can be specified for processing.    

Data File format:  Tab delimited (.txt) file with the following columns:  

DateTime V1  V2  V3  V4  ...
or
Date  Time V1  V2  V3  V4  ...

Alternate data file format:  Comma delimited with the same columns as above.  
}
\section{Output Data:}{  
Sample graphics output file:  See Output section on the web site for a sample of a full output file.  All graphs have the input data filename to clearly identify the data file under analysis, and a timestamp to show the time of analysis.  Each graph also lists the column name being analyzed (or averaged),  and the starting and ending times of analysis, as they vary slightly from the full data set (Lum to binEnd).    
Possible values:  jpg, pdf, tif, png

Output Data files:  A machine readable .txt file can be exported using Output parameter, by setting DAT=T.  
%%  ~~ If necessary, more details than the description above ~~
}

\references{http://564394709114639785.weebly.com/running-cat.html
%% ~put references to the literature/web site here ~
}
\author{Cathy Lee Gierke, Germaine Cornelissen-Guillaume, John A Lindgren

Maintainer: \email{ <leegi001@umn.edu>}
}
%%  ~~who you are~~

%% ~Make other sections like Warning with \section{Warning }{....} ~

\examples{
#  multiple-components cosinor analysis of 24, 12 and 8 hours.  Columns 4,6,7 are processed.  
#Data is systolic and dialstolic blood pressure; and heart rate at 30 minute intervals.
CATCosinor(TimeCol=2,Y=c(4,6,7), Components=3, window="noFilt", RefDateTime="201302030000",  timeFormat="%Y%m%d%H%M", RangeDateTime=list(Start=0, End=0), Units='Hour', dt=0, Progressive=list(Span=0, Increment=0), Period=list(Set=c(24,12,8),Start=0,Increment=1,End=0),header=F, Skip=0, Colors="BW",Graphics="pdf",Output=list(Txt=F,Dat=T,TxtAmp=F,Doc=T,HeatMap=F,LineGraphs=F),Console=F,Debug=FALSE,fileName="clgi001.dat",functionName='CallCosclgi001') 

# multiple-component cosinor analysis of 24 and 24.8 hours.  Columns 2,3,4 are  processed.
# Reference date-time is midnight before the date and time of the first data
CATCosinor(TimeCol=1,Y=c(2,3,4), Components=2, window="noFilt", RefDateTime="12",  timeFormat="%Y%m%d%H%M", RangeDateTime=list(Start=0, End=0), Units='Hour', dt=0, Progressive=list(Span=0, Increment=0), Period=list(Set=c(24,24.8),Start=0,Increment=1,End=0),header=F, Skip=0, Colors="BW",Graphics="pdf",Output=list(Txt=F,Dat=T,TxtAmp=F,Doc=T,HeatMap=F,LineGraphs=F),Console=F,Debug=FALSE,fileName=fileName,functionName='JF038')

}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~ Cosinor }
\keyword{ ~ multi-component }
\keyword{ ~ single-component }
\keyword{ ~ regression }
\keyword{ ~ least squares }
\keyword{ ~ spectrum }
\keyword{ ~ chronomics }
